Gecode::NaryPropagator< View, pc > Class Template Reference

n-ary propagator More...

`#include <pattern.hpp>`

## Public Member Functions

virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low linear).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| NaryPropagator (Space &home, NaryPropagator &p)
| Constructor for cloning p.
| NaryPropagator (Space &home, Propagator &p, ViewArray< View > &x)
| Constructor for rewriting p during cloning.
| NaryPropagator (Home home, ViewArray< View > &x)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

ViewArray< View > | x
| Array of views.

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class View, PropCond pc>
class Gecode::NaryPropagator< View, pc >

n-ary propagator

Stores array of views of type View with propagation condition pc.

If the propagation condition pc has the value PC_GEN_NONE, no subscriptions are created.

Definition at line 142 of file pattern.hpp.

## Constructor & Destructor Documentation

## NaryPropagator() [1/3]

template<class View, PropCond pc>

Gecode::NaryPropagator< View, pc >::NaryPropagator | ( | Space & | home,
|  | NaryPropagator< View, pc > & | p )

protected

Constructor for cloning p.

## NaryPropagator() [2/3]

template<class View, PropCond pc>

Gecode::NaryPropagator< View, pc >::NaryPropagator | ( | Space & | home,
|  | Propagator & | p,
|  | ViewArray< View > & | x )

inline protected

Constructor for rewriting p during cloning.

Definition at line 492 of file pattern.hpp.

## NaryPropagator() [3/3]

template<class View, PropCond pc>

Gecode::NaryPropagator< View, pc >::NaryPropagator | ( | Home | home,
|  | ViewArray< View > & | x )

protected

Constructor for creation.

Definition at line 475 of file pattern.hpp.

## Member Function Documentation

## cost()

template<class View, PropCond pc>

PropCost Gecode::NaryPropagator< View, pc >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low linear).

Implements Gecode::Propagator.

Reimplemented in Gecode::Action::Recorder< View >, Gecode::CHB::Recorder< View >, Gecode::Float::Rel::NaryEq< View >, Gecode::Int::Bool::NaryEq< BV >, Gecode::Int::Bool::NaryLq< VX >, Gecode::Int::Circuit::Dom< View, Offset >, Gecode::Int::Circuit::Val< View, Offset >, Gecode::Int::Distinct::Dom< View >, Gecode::Int::Precede::Single< View >, Gecode::Int::Rel::NaryEqBnd< View >, Gecode::Int::Rel::NaryEqDom< View >, Gecode::Int::Rel::NaryLqLe< View, o >, Gecode::Int::Rel::NaryNq< View >, and Gecode::Set::Precede::Single< View >.

Definition at line 500 of file pattern.hpp.

## reschedule()

template<class View, PropCond pc>

void Gecode::NaryPropagator< View, pc >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Reimplemented in Gecode::Action::Recorder< View >, Gecode::CHB::Recorder< View >, Gecode::Int::Circuit::Dom< View, Offset >, Gecode::Int::Precede::Single< View >, Gecode::Int::Rel::NaryLqLe< View, o >, and Gecode::Set::Precede::Single< View >.

Definition at line 506 of file pattern.hpp.

## dispose()

template<class View, PropCond pc>

size_t Gecode::NaryPropagator< View, pc >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Reimplemented in Gecode::Action::Recorder< View >, Gecode::CHB::Recorder< View >, Gecode::Int::Bool::NaryLq< VX >, Gecode::Int::Circuit::Base< View, Offset >, Gecode::Int::Precede::Single< View >, Gecode::Int::Rel::NaryLqLe< View, o >, Gecode::Int::Rel::NaryNq< View >, and Gecode::Set::Precede::Single< View >.

Definition at line 513 of file pattern.hpp.

## Member Data Documentation

## x

template<class View, PropCond pc>

ViewArray<View> Gecode::NaryPropagator< View, pc >::x

protected

Array of views.

Definition at line 145 of file pattern.hpp.

The documentation for this class was generated from the following file:

- gecode/kernel/propagator/pattern.hpp